




















                            SpeedBak User's Manual

                                  Revision A
                                January 4, 1992
                        Copyright (C) 1992 MICROTOOLS







1      SpeedBak Introduction

       Welcome to SpeedBak.  SpeedBak is a powerful, safe  yet
       simple means of restoring the speed you once had on your
       hard drive.   Files stored on your disks can be scattered
       (fragmented) all over your drive.  When you want to use
       them, the disk drive must jump all over the disk to retrieve
       the necessary data.  SpeedBak performs three basic
       functions:

          1.  Files that are fragmented are merged into one
              contiguous set of data on your disk to speed up disk
              access.
          2.  All space between files is removed to minimize your
              need to run SpeedBak as frequently.  Some programs
              give you the option to only defragment your files.
              Although this will cause the defragmenter to run
              quickly, it is generally pretty useless.
          3.  Removes unused directory entries.

       With these files defragmented and all of the free space on
       your disk in one place, your hard drive will have the speed
       you once knew back.

       SpeedBak is the fastest defragmenter in the known world.  We
       have tested it against all of the major commercial
       competitors using large drives and repeatable random
       fragmentation.

2      Installing SpeedBak

       SpeedBak is installed by either copying the necessary files
       to the desired directory or by typing A:INSTALL.  The
       INSTALL batch file will copy the programs to \SPEEDBAK.

3      Invoking SpeedBak

       SpeedBak can be invoked from the command line as follows
       (assuming it is in your path):

       C:>SPEEDBAK [switches]  [drive]

              where the optional switches are:
                 /C        for allowing you to zero unused data.  Use
                           this if you are paranoid about your data.

              where [drive] is the optional drive specification
                 (including the colon).  If no drive is specified,
                 the default drive is defragmented.

       SpeedBak should be run with all TSR's removed and all
       network drivers removed.  This is for your safety and the
       safety of your data.  The TSR world is a jungle and who
       knows what they can do.  Even the most benign might be
       lurking in the background just waiting to snag your data.

       In addition, SpeedBak should not be run from a multi-tasking
       environment like DesqView or Windows.  SpeedBak detects some
       of these environments, but SpeedBak must be the only thing
       running while defragmenting your disk.

4      Using SpeedBak

       All operation options are self-explanatory.  Options may be
       chosen by selecting the highlighted hot key or selecting
       with the left mouse button.

       Once started, SpeedBak can be aborted with the <Esc> key or
       the right mouse button.

       When SpeedBak starts, it analyzes the drive specified (or
       the default drive) to determine a number of statistics for
       the drive.  The following definitions are applicable to the
       statistics screen:

          Fragmented files - These are files whose contents do not
          occupy contiguous data blocks (sectors) on the disk.

          Non-fragmented files - These are files whose contents are
          contiguous.

          Directories - These are the special files that are used
          to organize your disk into manageable sections.

          Used Clusters - A cluster is the minimum sized data block
          used by DOS to manage files.  These clusters are managed
          in the File Allocation Table (FAT).  A used cluster is
          one that has been allocated by one and only one file.

          Largest Directory - This number indicates how many
          clusters the largest directory uses.

          Free Clusters - A free cluster is data block that has not
          been allocated by a file.

          File Fragments - This number indicates how extra
          fragments are on the disk.  For example, if there was
          only one fragmented file and it was divided into two
          fragments, the number of file fragments would be one (not
          two since every file has at least one "fragment").

          Unmovable files - SpeedBak moves many files in the course
          of defragmenting your disk.  Certain files are not moved
          due to a variety of technical reasons.   Certain copy
          protection schemes have forced programs like SpeedBak to
          not move these files.  See section 5 for further details
          as to which files are not movable.  Since these files are
          not moved, they can cause a certain amount of
          fragmentation on your disk.

          Bad Clusters - When a disk is formatted, the formatting
          program marks certain data blocks (clusters) as bad or
          not usable.  These data blocks are not used by DOS and
          will not be used by SpeedBak.

          Directory Clusters - This number indicates the number of
          clusters used by all of the directories.

          Largest File - This number indicates the number of
          clusters used by the largest file.

          Blocks of free clusters - This number indicates how many
          contiguous blocks of free clusters exist.

       When defragmenting a hard drive, you will be forced to re-
       boot!  Some programs do not force this at the risk of your
       hard drive!  There are too many times that users do not heed
       the warning to remove network drives and TSR's to not do
       this.  When defragments a floppy drive, you will be given
       the option.


5      Technical Details

       SpeedBak has chosen what we have determined as the optimum
       method of placing the files on your hard disk.  SpeedBak
       will place all of your directories at the front of the disk
       (closest to the FAT).  After that, all files are placed in a
       best fit algorithm.

       Certain files are not moved by SpeedBak because of copy
       protection algorithms used by other vendors.  The following
       files are not moved:

          All system and hidden files as well as:

            DCONFIG.SYS           MIO.SYS
            IBMBIO.COM            MSDOS.SYS
            IBMDOS.COM            SSTORDRV.SYS
            INSTALL.EXE           TBIOS.SYS
            IO.BIN                TDOS.SYS
            IO.SYS

6      Errors

       Under a variety of circumstances, SpeedBak may report
       errors.

       As mentioned, previously, if SpeedBak detects a multi-
       tasking environment, it will print out one of the following
       errors where XYZ is the multi-tasking environment:

          XYZ is active.  SpeedBak should be run from DOS with all
          TSRs and multitasking programs removed from memory.
          Please remove XYZ from memory.

       Every program has it's limits.  SpeedBak has certain limits
       around which it is designed.  It is designed to only handle
       a certain number of files, directories, requires a certain
       amount of memory and requires a small amount of disk space.
       If any of the following occur, and you are a registered
       user, please call technical support to discuss the
       possibility of increasing these design limitations:

          Cannot handle more than 16384 files
          Cannot handle more than 600 directories
          Must have at least 8192 free bytes on disk
          Must have at least 4 clusters free on disk
          Out of memory

       There are certain hardware errors that should never occur
       unless your machine is ill.  The following are indicative of
       a serious hardware problem on your machine:

          Read error
          Write error, disk may be write protected.


       If SpeedBak detects a file structure problem on your disk,
       it uses CHKDSK to correct it.  SpeedBak must be able to find
       it.  If it cannot, you will get the following message:

          Unable to start chkdsk, Please run chkdsk/f on drive

       Lastly, there are those errors that seem like they are the
       user's fault.  But since the customer is always right, we
       report it as an error.  It is difficult to defragment a disk
       that has no files on it.

          No files on disk

